#
# Copyright (c) Ensim Corporation, 2003   All Rights Reserved.
#
# This software is furnished under a license and may be used and copied
# only  in  accordance  with  the  terms  of such  license and with the
# inclusion of the above copyright notice. This software or any other
# copies thereof may not be provided or otherwise made available to any
# other person. No title to and ownership of the software is hereby
# transferred.
#
# The information in this software is subject to change without notice
# and  should  not be  construed  as  a commitment by Ensim Corporation.
# Ensim assumes no responsibility for the use or  reliability  of its
# software on equipment which is not supplied by Ensim.
#
import deployables_lib as dl
import urlparse
import shutil
import os

dl.load_msgs_module("phprojekt-4.0.4", symtab = globals())

dir_moves = [('phprojekt-4.0.4', '')]
file_mods = [{'path' : 'config.inc.php', 'create' : '', 'perms' : 0644},
             {'path' : 'upload/', 'create' : '', 'delete' : ''},
             {'path' : 'chat/', 'delete' : ''},
             {'path' : 'attach/', 'delete' : ''}]
secure_files = [('config.inc.php', 0600, 0644),
                ('upload', 0700, 0777),
                ('chat', 0700, 0777),
                ('attach', 0700, 0777)]
instance_patches = []

pat = "^\s*\$(?P<key>[a-zA-Z_]+)\s*=\s*(\"|')(?P<value>.*)(\"|')\s*;(?P<comment>.*)$"
sub = "$%(key)s = %(value)s;%(comment)s"

def install(site, site_conf, instance_conf, msgs):

    actions = ['resolve_location', 'check_disk_quota', 'check_mysql_enabled', 
	       'check_pass', 'check_install_loc_owner', '']
    args_dict = {}
    dl.do_install_actions(site, site_conf, instance_conf, msgs,
                          globals(), actions, args_dict)
    if msgs.get_severity() != msgs.ERROR:
        sql_stmts = ["DELETE FROM users WHERE loginname = 'test'",
                     "UPDATE users SET loginname = '%s', email = '%s' WHERE "
                     "loginname = 'root'" % (instance_conf['instance_admin'],
                                             instance_conf['instance_admin_email'])]
        # Script args after 'rts_mail' came from the second page of
        # options
        comps = urlparse.urlsplit(instance_conf['url_loc'])
        website = urlparse.urlunsplit((comps[0], comps[1], '', '', ''))
        actions = ['db_create', 'db_probe', 'archive_unpack', 'check_index',
                   'exec_php_script', 'exec_mysql',
                   'handle_security_mode', 'access_url']
        args_dict = {
            'archive_unpack':       {'dir_moves': dir_moves,
                                     'file_mods' : file_mods},
            'handle_security_mode': {'files': secure_files},
            'exec_php_script' : {
                 'script' : 'setup.php',
                 'args' : {'step' : '3',
                           'setup' : 'install',
                           'langua' : 'en',
                           'db_type' : 'mysql',
                           'db_host' : dl.get_mysql_host(site),
                           'db_user' : site_conf['mysql']['dbaseadmin'], 
                           'db_pass' : instance_conf['dbpass'],
                           'db_name' : instance_conf['dbname'],
                           'calendar' : '1',
                           'timecard' : '2',
                           'projekte' : '2',
                           'adressen' : '1',
                           'contacts_profiles' : '',
                           'profile' : '1',
                           'ressourcen' : '1',
                           'todo' : '1',
                           'forum' : '1',
                           'notes' : '1',
                           'votum' : '1',
                           'lesezeichen' : '1',
                           'chat' : '1',
                           'quickmail' : '2',
                           'faxpath' : '',
                           'reminder' : '2',
                           'remind_freq' : '15',
                           'dat_rel' : 'upload',
                           'dateien' : 
                              (instance_conf['install_loc'] + '/upload',
                               dl.MODSTR_JAIL),
                           'dat_crypt' : '1',
                           'rts' : '1',
                           'rts_duedate' : '',
                           'rts_cust_acc' : '',
                           'rts_chef' : '',
                           'rts_mail' : instance_conf['instance_admin_email'], 
                           'rootpass' : instance_conf['instance_pass1'],
                           'groups' : '1',
                           'login' : '0',
                           'login_kurz' : '2',
                           'ldap' : '0',
                           'logs' : '',
                           'timezone' : '0',
                           'pw_crypt' : '1',
                           'pw_change' : '1',
                           'mail_new_event' : '1',
                           'groupviewuserheader' : '1',
                           'cur_symbol' : '$',
                           'tagesanfang' : '8',
                           'tagesende' : '20',
                           'bgcolor1' : '#C2C2C2',
                           'bgcolor2' : '#D5D5D5',
                           'bgcolor3' : '#E0E0E0',
                           'terminfarbe' : '#FFFFFF',
                           'logo' : 'img/logo.gif',
                           'hp_url' : website,
                           'tr_hover' : '1',
                           'cont_usrdef1' : 'Userdefined 1',
                           'cont_usrdef2' : 'Userdefined 2'},
                 'success_re' : '.*Finished!'},
            'exec_mysql' : {'sql' : sql_stmts}
            }
        dl.do_install_actions(site, site_conf, instance_conf, msgs,
                              globals(), actions, args_dict)

def reconfigure(context, site, site_conf, old_site_conf, instance_conf,
                old_instance_conf, msgs):

    actions = ['handle_url_loc', 'resolve_location', '', 'archive_unpack',
               'handle_username_change', 'handle_db_changes']
    args_dict = {
            'archive_unpack':       { 'dir_moves': dir_moves,
                                      'file_mods' : file_mods,
                                      'fileinfo' :
                                      {'excluded_files' :['config.inc.php']}}}
    if context != dl.CONTEXT_SITE_EDIT and instance_conf.get('dbpass'):
        actions.insert(0, 'db_probe')
        args_dict['db_probe'] = {'use_old' : 1}
    dl.do_reconfigure_actions(context, site, site_conf, old_site_conf,
                              instance_conf, old_instance_conf, msgs,
                              globals(), actions, args_dict)
    if msgs.get_severity() != msgs.ERROR:
        old_upload = "%s%s" % (dl.site_fs_jail(site, old_site_conf),
			       instance_conf['install_loc'] + '/upload')
        new_upload = "%s%s" % (dl.site_fs_jail(site, site_conf),
			       instance_conf['install_loc'] + '/upload')
        vars = [('dateien', new_upload, old_upload)] 
        if dl.mysql_installed(site_conf, old_site_conf):
            vars.extend([('db_user', site_conf['mysql']['dbaseadmin'],
                          old_site_conf['mysql']['dbaseadmin']),
                         ('db_name', instance_conf['dbname'],
                          old_instance_conf['dbname'])])
        if context != dl.CONTEXT_SITE_EDIT:
            # We will only change the mysql host if a user specifically
            # invokes reconfigure; we don't want this change to happen
            # during upgrade, when all the sites are edited, but the
            # mysql.sock file hasn't moved yet.
            vars.append(('db_host', dl.get_mysql_host(site)))
            if instance_conf.get('dbpass'):
                vars.append(('db_pass', instance_conf['dbpass']))
        actions2 = ['edit_conf_file', 'apply_patch', 'handle_security_mode']
        args_dict = {
            'handle_security_mode': { 'files': secure_files },
            'edit_conf_file' : {'file' : 'config.inc.php', 'lang' : 'php',
                                'pat' : pat, 'sub' : sub, 'vars' : vars},
            'apply_patch' : {'patches' : instance_patches}
            }
        dl.do_reconfigure_actions(context, site, site_conf, old_site_conf,
                                  instance_conf, old_instance_conf, msgs,
                                  globals(), actions2, args_dict)
        
        
def remove(site, site_conf, instance_conf, msgs):
    dl.db_drop(site, site_conf, instance_conf)
    dl.install_loc_cleanup(site, site_conf, instance_conf, dir_moves,
                           file_mods = file_mods)
    
def get_instance_configuration(context, site, site_conf, instance_conf,
                               old_instance_conf, locale, msgs):
    instance = dl.dsp_create_instance(instance_conf['shortname'],
                                      instance_conf['version'])
    dl.dsp_fill_instance(context, instance, site, site_conf,
                         instance_conf, old_instance_conf,
                         ['dbname', 'username', 'url_net', 'url_path',
                          'domain_to_path', 'instance_admin_email'])
    dl.enable_patches(instance, instance_patches)
    return instance

def regression_test(action, index, test_data):
    return dl.regression_check_index(action, index, test_data,
                                     'Login')
